"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.typedPath = void 0;
function appendStringPathChunk(path, chunk) {
    if (typeof chunk === 'number') {
        return path + ("[" + chunk + "]");
    }
    else {
        return appendStringSymbolChunkToPath(path, chunk);
    }
}
function appendStringSymbolChunkToPath(path, chunk) {
    return path + (path === '' ? chunk.toString() : "." + chunk.toString());
}
function pathToString(path) {
    return path.reduce(function (current, next) {
        return appendStringPathChunk(current, next);
    }, '');
}
var defaultHandlersConfig = (_a = {
        $path: function (path) { return pathToString(path); },
        /**
         * @deprecated This method transforms all path chunks to strings.
         * If you need the path with numbers and Symbols - use $rawPath
         */
        $raw: function (path) { return path.map(function (chunk) { return chunk.toString(); }); },
        $rawPath: function (path) { return path; },
        toString: function (path) { return function () { return pathToString(path); }; }
    },
    _a[Symbol.toStringTag] = function (path) { return pathToString(path); },
    _a.valueOf = function (path) { return function () { return pathToString(path); }; },
    _a);
function convertNumericKeyToNumber(key) {
    if (typeof key === 'string') {
        var keyAsNumber = +key;
        if (keyAsNumber === keyAsNumber) {
            return keyAsNumber;
        }
    }
    return key;
}
function getHandlerByNameKey(name, additionalHandlers) {
    if (additionalHandlers === null || additionalHandlers === void 0 ? void 0 : additionalHandlers.hasOwnProperty(name)) {
        return additionalHandlers[name];
    }
    if (defaultHandlersConfig[name]) {
        return defaultHandlersConfig[name];
    }
}
var emptyObject = {};
function typedPath(additionalHandlers, path) {
    if (path === void 0) { path = []; }
    return new Proxy(emptyObject, {
        get: function (target, name) {
            var handler = getHandlerByNameKey(name, additionalHandlers);
            return handler
                ? handler(path, additionalHandlers)
                : typedPath(additionalHandlers, __spreadArray(__spreadArray([], path), [convertNumericKeyToNumber(name)]));
        }
    });
}
exports.typedPath = typedPath;
//# sourceMappingURL=index.js.map